Index: contrib/openbsm/libbsm/bsm_errno.c
===================================================================
--- contrib/openbsm/libbsm/bsm_errno.c	(.../stable/8)	(revision 201781)
+++ contrib/openbsm/libbsm/bsm_errno.c	(.../projects/capabilities8)	(revision 205872)
@@ -684,6 +684,13 @@
 	ERRNO_NO_LOCAL_MAPPING,
 #endif
 	ES("Key was rejected by service") },
+	{ BSM_ERRNO_ENOTCAPABLE,
+#ifdef ENOTCAPABLE
+	ENOTCAPABLE,
+#else
+	ERRNO_NO_LOCAL_MAPPING,
+#endif
+	ES("Capabilities insufficient") },
 };
 static const int bsm_errnos_count = sizeof(bsm_errnos) / sizeof(bsm_errnos[0]);
 
Index: contrib/openbsm/sys/bsm/audit_errno.h
===================================================================
--- contrib/openbsm/sys/bsm/audit_errno.h	(.../stable/8)	(revision 201781)
+++ contrib/openbsm/sys/bsm/audit_errno.h	(.../projects/capabilities8)	(revision 205872)
@@ -204,6 +204,7 @@
 #define	BSM_ERRNO_EKEYEXPIRED		220	/* Linux-specific. */
 #define	BSM_ERRNO_EKEYREVOKED		221	/* Linux-specific. */
 #define	BSM_ERRNO_EKEYREJECTED		222	/* Linux-specific. */
+#define	BSM_ERRNO_ENOTCAPABLE		223	/* FreeBSD-specific. */
 
 /*
  * In the event that OpenBSM doesn't have a file representation of a local

Index: contrib/tcpdump/tcpdump.c
===================================================================
--- contrib/tcpdump/tcpdump.c	(.../stable/8)	(revision 201781)
+++ contrib/tcpdump/tcpdump.c	(.../projects/capabilities8)	(revision 205872)
@@ -76,6 +76,7 @@
 #include <errno.h>
 #endif /* WIN32 */
 
+#include <sys/capability.h>
 
 #include "netdissect.h"
 #include "interface.h"
@@ -1197,6 +1198,8 @@
 		(void)fflush(stderr);
 	}
 #endif /* WIN32 */
+	if (cap_enter() < 0)
+		error("cap_enter: %s", pcap_strerror(errno));
 	status = pcap_loop(pd, cnt, callback, pcap_userdata);
 	if (WFileName == NULL) {
 		/*

Index: share/mk/bsd.libnames.mk
===================================================================
--- share/mk/bsd.libnames.mk	(.../stable/8)	(revision 201781)
+++ share/mk/bsd.libnames.mk	(.../projects/capabilities8)	(revision 205872)
@@ -30,6 +30,7 @@
 LIBC_PIC?=	${DESTDIR}${LIBDIR}/libc_pic.a
 LIBCALENDAR?=	${DESTDIR}${LIBDIR}/libcalendar.a
 LIBCAM?=	${DESTDIR}${LIBDIR}/libcam.a
+LIBCAPSICUM?=	${DESTDIR}${LIBDIR}/libcapsicum.a
 LIBCOM_ERR?=	${DESTDIR}${LIBDIR}/libcom_err.a
 LIBCOMPAT?=	${DESTDIR}${LIBDIR}/libcompat.a
 LIBCRYPT?=	${DESTDIR}${LIBDIR}/libcrypt.a
Index: lib/libc/gen/Makefile.inc
===================================================================
--- lib/libc/gen/Makefile.inc	(.../stable/8)	(revision 201781)
+++ lib/libc/gen/Makefile.inc	(.../projects/capabilities8)	(revision 205872)
@@ -20,6 +20,7 @@
 	getpeereid.c getprogname.c getpwent.c getttyent.c \
 	getusershell.c getvfsbyname.c glob.c \
 	initgroups.c isatty.c isinf.c isnan.c jrand48.c lcong48.c \
+	ld_libdirs.c ld_sandbox.c \
 	lockf.c lrand48.c mrand48.c nftw.c nice.c \
 	nlist.c nrand48.c opendir.c \
 	pause.c pmadvise.c popen.c posix_spawn.c \
@@ -77,6 +78,7 @@
 
 MLINKS+=arc4random.3 arc4random_addrandom.3 arc4random.3 arc4random_stir.3 \
 	arc4random.3 arc4random_buf.3 arc4random.3 arc4random_uniform.3
+MLINKS+=basename.3 basename_r.3
 MLINKS+=ctermid.3 ctermid_r.3
 MLINKS+=devname.3 devname_r.3
 MLINKS+=devname.3 fdevname.3
Index: lib/libc/gen/ld_sandbox.c
===================================================================
--- lib/libc/gen/ld_sandbox.c	(.../stable/8)	(revision 0)
+++ lib/libc/gen/ld_sandbox.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,40 @@
+/*-
+ * Copyright (c) 2008-2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ * 
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc. 
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#pragma weak ld_insandbox
+int
+ld_insandbox(void)
+{
+
+	return (0);
+}

Index: lib/libc/gen/basename.c
===================================================================
--- lib/libc/gen/basename.c	(.../stable/8)	(revision 201781)
+++ lib/libc/gen/basename.c	(.../projects/capabilities8)	(revision 205872)
@@ -40,18 +40,12 @@
 #include <sys/param.h>
 
 char *
-basename(path)
+basename_r(path, bname)
 	const char *path;
+	char *bname;
 {
-	static char *bname = NULL;
 	const char *endp, *startp;
 
- 	if (bname == NULL) {
-		bname = (char *)malloc(MAXPATHLEN);
-		if (bname == NULL)
-			return(NULL);
-	}
-
 	/* Empty or NULL string gets treated as "." */
 	if (path == NULL || *path == '\0') {
 		(void)strcpy(bname, ".");
@@ -82,3 +76,17 @@
 	bname[endp - startp + 1] = '\0';
 	return(bname);
 }
+
+char *
+basename(path)
+	const char *path;
+{
+	static char *bname = NULL;
+
+	if (bname == NULL) {
+		bname = (char *)malloc(MAXPATHLEN);
+		if (bname == NULL)
+			return (NULL);
+	}
+	return (basename_r(path, bname));
+}
Index: lib/libc/gen/ld_libdirs.c
===================================================================
--- lib/libc/gen/ld_libdirs.c	(.../stable/8)	(revision 0)
+++ lib/libc/gen/ld_libdirs.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,44 @@
+/*-
+ * Copyright (c) 2010 Jonathan Anderson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ * 
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc. 
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <errno.h>
+
+#pragma weak ld_libdirs
+int
+ld_libdirs(int *fds, int *fdlen)
+{
+
+	errno = EOPNOTSUPP;
+	return (-1);
+}
+
Index: lib/libc/sys/Makefile.inc
===================================================================
--- lib/libc/sys/Makefile.inc	(.../stable/8)	(revision 201781)
+++ lib/libc/sys/Makefile.inc	(.../projects/capabilities8)	(revision 205872)
@@ -64,7 +64,7 @@
 MAN+=	abort2.2 accept.2 access.2 acct.2 adjtime.2 \
 	aio_cancel.2 aio_error.2 aio_read.2 aio_return.2 \
 	aio_suspend.2 aio_waitcomplete.2 aio_write.2 \
-	bind.2 brk.2 chdir.2 chflags.2 \
+	bind.2 brk.2 cap_enter.2 cap_new.2 chdir.2 chflags.2 \
 	chmod.2 chown.2 chroot.2 clock_gettime.2 close.2 closefrom.2 \
 	connect.2 cpuset.2 cpuset_getaffinity.2 dup.2 execve.2 _exit.2 \
 	extattr_get_file.2 fcntl.2 fhopen.2 flock.2 fork.2 fsync.2 \
@@ -83,7 +83,7 @@
 	mq_setattr.2 \
 	msgctl.2 msgget.2 msgrcv.2 msgsnd.2 \
 	msync.2 munmap.2 nanosleep.2 nfssvc.2 ntp_adjtime.2 open.2 \
-	pathconf.2 pipe.2 poll.2 posix_openpt.2 profil.2 \
+	pathconf.2 pdfork.2 pipe.2 poll.2 posix_openpt.2 profil.2 \
 	pselect.2 ptrace.2 quotactl.2 \
 	read.2 readlink.2 reboot.2 recv.2 rename.2 revoke.2 rfork.2 rmdir.2 \
 	rtprio.2
@@ -105,6 +105,8 @@
 
 MLINKS+=access.2 eaccess.2 access.2 faccessat.2
 MLINKS+=brk.2 sbrk.2
+MLINKS+=cap_enter.2 cap_getmode.2
+MLINKS+=cap_new.2 cap_getrights.2
 MLINKS+=chdir.2 fchdir.2
 MLINKS+=chflags.2 fchflags.2 chflags.2 lchflags.2
 MLINKS+=chmod.2 fchmod.2 chmod.2 fchmodat.2 chmod.2 lchmod.2
@@ -162,6 +164,9 @@
 MLINKS+=open.2 openat.2
 MLINKS+=pathconf.2 fpathconf.2
 MLINKS+=pathconf.2 lpathconf.2
+MLINKS+=pdfork.2 pdgetpid.2 \
+	pdfork.2 pdkill.2 \
+	pdfork.2 pdwait4.2
 MLINKS+=read.2 pread.2 read.2 preadv.2 read.2 readv.2
 MLINKS+=readlink.2 readlinkat.2
 MLINKS+=recv.2 recvfrom.2 recv.2 recvmsg.2
Index: lib/Makefile
===================================================================
--- lib/Makefile	(.../stable/8)	(revision 201781)
+++ lib/Makefile	(.../projects/capabilities8)	(revision 205872)
@@ -32,7 +32,9 @@
 	ncurses ${_libnetgraph} libradius librpcsvc libsbuf \
 	libtacplus libutil ${_libypclnt} libalias libarchive ${_libatm} \
 	libbegemot ${_libbluetooth} ${_libbsnmp} libbz2 \
-	libcalendar libcam libcompat libdevinfo libdevstat libdisk \
+	libcalendar libcam libcapsicum libcompat \
+	libdevinfo libdevstat \
+	libdisk \
 	libdwarf libedit libexpat libfetch libftpio libgeom ${_libgpib} \
 	${_libgssapi} ${_librpcsec_gss} libipsec \
 	${_libipx} libjail libkiconv libmagic libmemstat ${_libmilter} \

Index: lib/libkvm/kvm_proc.c
===================================================================
--- lib/libkvm/kvm_proc.c	(.../stable/8)	(revision 201781)
+++ lib/libkvm/kvm_proc.c	(.../projects/capabilities8)	(revision 205872)
@@ -154,6 +154,7 @@
 			kvm_read(kd, (u_long)ucred.cr_groups, kp->ki_groups,
 			    kp->ki_ngroups * sizeof(gid_t));
 			kp->ki_uid = ucred.cr_uid;
+			kp->ki_cr_flags = ucred.cr_flags;
 			if (ucred.cr_prison != NULL) {
 				if (KREAD(kd, (u_long)ucred.cr_prison, &pr)) {
 					_kvm_err(kd, kd->program,

Index: lib/libcapsicum/libcapsicum_host_io.c
===================================================================
--- lib/libcapsicum/libcapsicum_host_io.c	(.../stable/8)	(revision 0)
+++ lib/libcapsicum/libcapsicum_host_io.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,232 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $P4: //depot/projects/trustedbsd/capabilities/src/lib/libcapsicum/libcapsicum_host_io.c#3 $
+ */
+
+#include <sys/param.h>
+#include <sys/capability.h>
+#include <sys/procdesc.h>
+#include <sys/socket.h>
+#include <sys/uio.h>
+
+#include <errno.h>
+#include <fcntl.h>
+#include <libgen.h>
+#include <paths.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "libcapsicum.h"
+#include "libcapsicum_internal.h"
+#include "libcapsicum_sandbox_api.h"
+
+/*
+ * Simple I/O wrappers for capability sockets.  Possibly more keeping an eye
+ * on the worker should take place here.
+ */
+ssize_t
+lch_send(struct lc_sandbox *lcsp, const void *msg, size_t len, int flags)
+{
+
+	return (_lc_send(lcsp->lcs_fd_sock, msg, len, flags, 0));
+}
+
+ssize_t
+lch_send_rights(struct lc_sandbox *lcsp, const void *msg, size_t len,
+    int flags, int *fdp, int fdcount)
+{
+
+	return (_lc_send_rights(lcsp->lcs_fd_sock, msg, len, flags, 0, fdp,
+	    fdcount));
+}
+
+ssize_t
+lch_recv(struct lc_sandbox *lcsp, void *buf, size_t len, int flags)
+{
+
+	return (_lc_recv(lcsp->lcs_fd_sock, buf, len, flags, 0));
+}
+
+ssize_t
+lch_recv_rights(struct lc_sandbox *lcsp, void *buf, size_t len, int flags,
+    int *fdp, int *fdcountp)
+{
+
+	return (_lc_recv_rights(lcsp->lcs_fd_sock, buf, len, flags, 0, fdp,
+	    fdcountp));
+}
+
+/*
+ * Simple libcapsicum RPC facility (lcrpc): send a request, get back a
+ * reply (up to the size bound of the buffers passed in).  The caller is
+ * responsible for retransmitting if the sandbox fails.
+ *
+ * Right now sequence numbers are unimplemented -- that's fine because we
+ * don't need retransmission, and are synchronous.  However, it might not be
+ * a bad idea to use them anyway.
+ */
+static int
+lch_rpc_internal(struct lc_sandbox *lcsp, u_int32_t opno, struct iovec *req,
+    int reqcount, int *req_fdp, int req_fdcount, struct iovec *rep,
+    int repcount, size_t *replenp, int *rep_fdp, int *rep_fdcountp)
+{
+	struct lcrpc_request_hdr req_hdr;
+	struct lcrpc_reply_hdr rep_hdr;
+	size_t left, off, space, totlen, want;
+	ssize_t len;
+	int i;
+
+	bzero(&req_hdr, sizeof(req_hdr));
+	req_hdr.lcrpc_reqhdr_magic = LCRPC_REQUEST_HDR_MAGIC;
+	req_hdr.lcrpc_reqhdr_seqno = 0;
+	req_hdr.lcrpc_reqhdr_opno = opno;
+	for (i = 0; i < reqcount; i++)
+		req_hdr.lcrpc_reqhdr_datalen += req[i].iov_len;
+	for (i = 0; i < repcount; i++)
+		req_hdr.lcrpc_reqhdr_maxrepdatalen += rep[i].iov_len;
+
+	/*
+	 * Send our header.
+	 */
+	if (req_fdp != NULL)
+		len = _lc_send_rights(lcsp->lcs_fd_sock, &req_hdr,
+		    sizeof(req_hdr), 0, LC_IGNOREEINTR, req_fdp,
+		    req_fdcount);
+	else
+		len = _lc_send(lcsp->lcs_fd_sock, &req_hdr, sizeof(req_hdr),
+		    0, LC_IGNOREEINTR);
+	if (len < 0)
+		return (-1);
+	if (len != sizeof(req_hdr)) {
+		errno = ECHILD;
+		return (-1);
+	}
+
+	/*
+	 * Send the user request.
+	 */
+	for (i = 0; i < reqcount; i++) {
+		len = _lc_send(lcsp->lcs_fd_sock, req[i].iov_base,
+		    req[i].iov_len, 0, LC_IGNOREEINTR);
+		if (len < 0)
+			return (-1);
+		if ((size_t)len != req[i].iov_len) {
+			errno = ECHILD;
+			return (-1);
+		}
+	}
+
+	/*
+	 * Receive our header and validate.
+	 */
+	if (rep_fdp != NULL)
+		len = _lc_recv_rights(lcsp->lcs_fd_sock, &rep_hdr,
+		    sizeof(rep_hdr), MSG_WAITALL, LC_IGNOREEINTR, rep_fdp,
+		    rep_fdcountp);
+	else
+		len = _lc_recv(lcsp->lcs_fd_sock, &rep_hdr, sizeof(rep_hdr),
+		    MSG_WAITALL, LC_IGNOREEINTR);
+	if (len < 0)
+		return (-1);
+	if (len != sizeof(rep_hdr)) {
+		if (rep_fdp != NULL)
+			_lc_dispose_rights(rep_fdp, *rep_fdcountp);
+		errno = ECHILD;
+		return (-1);
+	}
+
+	if (rep_hdr.lcrpc_rephdr_magic != LCRPC_REPLY_HDR_MAGIC ||
+	    rep_hdr.lcrpc_rephdr_seqno != 0 ||
+	    rep_hdr.lcrpc_rephdr_opno != opno ||
+	    rep_hdr.lcrpc_rephdr_datalen > req_hdr.lcrpc_reqhdr_maxrepdatalen) {
+		if (rep_fdp != NULL)
+			_lc_dispose_rights(rep_fdp, *rep_fdcountp);
+		errno = EBADRPC;
+		return (-1);
+	}
+
+	/*
+	 * Receive the user data.  Notice that we can partially overwrite the
+	 * user buffer but still receive an error.
+	 */
+	totlen = 0;
+	for (i = 0; i < repcount; i++) {
+		off = 0;
+		while (totlen < rep_hdr.lcrpc_rephdr_datalen) {
+			space = rep[i].iov_len - off;
+			left = rep_hdr.lcrpc_rephdr_datalen - totlen;
+			want = (space > left) ? space : left;
+			len = _lc_recv(lcsp->lcs_fd_sock,
+			    (u_char *)((uintptr_t)rep[i].iov_base + off),
+			    want, MSG_WAITALL, LC_IGNOREEINTR);
+			if (len < 0)
+				return (-1);
+			if ((size_t)len != want) {
+				if (rep_fdp != NULL)
+					_lc_dispose_rights(rep_fdp,
+					    *rep_fdcountp);
+				errno = ECHILD;
+				return (-1);
+			}
+			off += len;
+			totlen += len;
+			if (rep[i].iov_len == off)
+				break;
+		}
+		if (totlen == rep_hdr.lcrpc_rephdr_datalen)
+			break;
+	}
+	*replenp = totlen;
+	return (0);
+}
+
+int
+lch_rpc(struct lc_sandbox *lcsp, u_int32_t opno, struct iovec *req,
+    int reqcount, struct iovec *rep, int repcount, size_t *replenp)
+{
+
+	return (lch_rpc_internal(lcsp, opno, req, reqcount, NULL, 0,
+	    rep, repcount, replenp, NULL, NULL));
+}
+
+int
+lch_rpc_rights(struct lc_sandbox *lcsp, u_int32_t opno, struct iovec *req,
+    int reqcount, int *req_fdp, int req_fdcount, struct iovec *rep,
+    int repcount, size_t *replenp, int *rep_fdp, int *rep_fdcountp)
+{
+
+	return (lch_rpc_internal(lcsp, opno, req, reqcount, req_fdp,
+	    req_fdcount, rep, repcount, replenp, rep_fdp, rep_fdcountp));
+}
Index: lib/libcapsicum/libcapsicum.h
===================================================================
--- lib/libcapsicum/libcapsicum.h	(.../stable/8)	(revision 0)
+++ lib/libcapsicum/libcapsicum.h	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,230 @@
+/*-
+ * Copyright (c) 2009-2010 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $P4: //depot/projects/trustedbsd/capabilities/src/lib/libcapsicum/libcapsicum.h#12 $
+ */
+
+#ifndef _LIBCAPSICUM_H_
+#define	_LIBCAPSICUM_H_
+
+#include <sys/cdefs.h>
+#include <sys/capability.h>
+
+__BEGIN_DECLS
+
+struct lc_sandbox;
+struct lc_host;
+
+/*
+ * A list of file descriptors, which can be passed around in shared memory.
+ */
+struct lc_fdlist;
+struct lc_fdlist	*lc_fdlist_new(void);
+struct lc_fdlist	*lc_fdlist_global(void);
+struct lc_fdlist	*lc_fdlist_dup(struct lc_fdlist *lfp_orig);
+void			 lc_fdlist_free(struct lc_fdlist *lfp);
+
+/*
+ * Size of an FD list in bytes, including all associated string data.
+ *
+ * XXX: This will probably become library-private soon.
+ */
+u_int	lc_fdlist_size(struct lc_fdlist *lfp);
+
+/*
+ * Add a file descriptor to the list.
+ *
+ * lfp		the list to add to
+ * subsystem	a software component name, e.g. "org.freebsd.rtld-elf-cap"
+ * classname	a class name, e.g. "libdir" or "library"
+ * name		an instance name, e.g. "system library dir" or "libc.so.6"
+ * fd		the file descriptor
+ */
+int	lc_fdlist_add(struct lc_fdlist *lfp, const char *subsystem,
+	    const char *classname, const char *name, int fd);
+
+/*
+ * Append the contents of one list to another.
+ */
+int	lc_fdlist_append(struct lc_fdlist *to, struct lc_fdlist *from);
+
+
+/*
+ * Like lc_fdlist_add(), but allows capability rights to be specified.  The
+ * file descriptor will be wrapped in a capability with the given rights (so
+ * if the descriptor *is* a capability, its rights will be constrained
+ * according to this rights mask.)
+ */
+int	lc_fdlist_addcap(struct lc_fdlist *l, const char *subsystem,
+	    const char *classname, const char *name, int fd,
+	    cap_rights_t rights);
+
+/*
+ * Look up a file descriptor.
+ *
+ * Multiple entries with the same classname are allowed, so iterating through
+ * all instances of a class is done by supplying an integer 'pos' which is
+ * used internally to skip entries which have already been seen.  If 'pos' is
+ * 0 or NULL, the first matching entry will be returned.
+ */
+int	lc_fdlist_lookup(struct lc_fdlist *lfp, const char *subsystem,
+	    const char *classname, char **name, int *fdp, int *pos);
+
+/*
+ * Look up a file descriptor without a name.  Repeated calls to this function
+ * will iterate through all descriptors in the list.
+ */
+int	lc_fdlist_getentry(struct lc_fdlist *lfp, char **subsystem,
+	    char **classname, char **name, int *fdp, int *pos);
+
+/*
+ * Reorder FD list (WARNING: this could be dangerous!).
+ *
+ * This call takes all of the file descriptors in the FD list, and moves them
+ * into a continuous array, starting at the FD given by 'start'.  Any file
+ * descriptors above 'start' which are not in the FD list are closed.
+ */
+int	lc_fdlist_reorder(struct lc_fdlist *lfp);
+
+/*
+ * Capability interfaces.
+ */
+int	lc_limitfd(int fd, cap_rights_t rights);
+
+/*
+ * Global policy interface to ask whether we should, in fact, sandbox a
+ * particular optionally sandboxed service, by name.
+ */
+int	lch_autosandbox_isenabled(const char *servicename);
+
+/*
+ * Interfaces to start and stop capability mode sandboxs.
+ */
+int	lch_start(const char *sandbox, char *const argv[], u_int flags,
+	    struct lc_fdlist *fds, struct lc_sandbox **lcspp);
+int	lch_start_libs(const char *sandbox, char *const argv[], u_int flags,
+	    struct lc_fdlist *fds, struct lc_sandbox **lcspp);
+int	lch_startfd(int fd_sandbox, const char *binname, char *const argv[],
+	    u_int flags, struct lc_fdlist *fds, struct lc_sandbox **lcspp);
+int	lch_startfd_libs(int fd_sandbox, const char *binname,
+	    char *const argv[], u_int flags, struct lc_fdlist *fds,
+	    struct lc_sandbox **lcspp);
+void	lch_stop(struct lc_sandbox *lcsp);
+
+/*
+ * Flags to lch_start_flags:
+ */
+#define	LCH_PERMIT_STDERR	0x00000001
+#define	LCH_PERMIT_STDOUT	0x00000002
+
+/*
+ * Interfaces to query state about capability mode sandboxs.
+ */
+int	lch_getsock(struct lc_sandbox *lcsp, int *fdp);
+int	lch_getpid(struct lc_sandbox *lcsp, pid_t *pidp);
+int	lch_getprocdesc(struct lc_sandbox *lcsp, int *fdp);
+
+/*
+ * Message-passing APIs for the host environment.
+ */
+struct iovec;
+ssize_t	lch_recv(struct lc_sandbox *lcsp, void *buf, size_t len, int flags);
+ssize_t	lch_recv_rights(struct lc_sandbox *lcsp, void *buf, size_t len,
+	    int flags, int *fdp, int *fdcountp);
+ssize_t	lch_send(struct lc_sandbox *lcsp, const void *msg, size_t len,
+	    int flags);
+ssize_t	lch_send_rights(struct lc_sandbox *lcsp, const void *msg, size_t len,
+	    int flags, int *fdp, int fdcount);
+
+/*
+ * RPC APIs for the host environment.
+ */
+int	lch_rpc(struct lc_sandbox *lcsp, u_int32_t opno, struct iovec *req,
+	    int reqcount, struct iovec *rep, int repcount, size_t *replenp);
+int	lch_rpc_rights(struct lc_sandbox *lcsp, u_int32_t opno,
+	    struct iovec *req, int reqcount, int *req_fdp, int req_fdcount,
+	    struct iovec *rep, int repcount, size_t *replenp, int *rep_fdp,
+	    int *rep_fdcountp);
+
+/*
+ * Interfaces to query state from within capability mode sandboxes.
+ */
+int	lcs_get(struct lc_host **lchpp);
+int	lcs_getsock(struct lc_host *lchp, int *fdp);
+
+/*
+ * Message-passing APIs for the sandbox environment.
+ */
+ssize_t	lcs_recv(struct lc_host *lchp, void *buf, size_t len, int flags);
+ssize_t	lcs_recv_rights(struct lc_host *lchp, void *buf, size_t len,
+	    int flags, int *fdp, int *fdcountp);
+ssize_t	lcs_send(struct lc_host *lchp, const void *msg, size_t len,
+	    int flags);
+ssize_t	lcs_send_rights(struct lc_host *lchp, const void *msg, size_t len,
+	    int flags, int *fdp, int fdcount);
+
+/*
+ * RPC APIs for the sandbox environment.
+ */
+int	lcs_recvrpc(struct lc_host *lchp, u_int32_t *opnop,
+	    u_int32_t *seqnop, u_char **bufferp, size_t *lenp);
+int	lcs_recvrpc_rights(struct lc_host *lchp, u_int32_t *opnop,
+	    u_int32_t *seqnop, u_char **bufferp, size_t *lenp, int *fdp,
+	    int *fdcountp);
+int	lcs_sendrpc(struct lc_host *lchp, u_int32_t opno, u_int32_t seqno,
+	    struct iovec *rep, int repcount);
+int	lcs_sendrpc_rights(struct lc_host *lchp, u_int32_t opno,
+	    u_int32_t seqno, struct iovec *rep, int repcount, int *fdp,
+	    int fdcount);
+
+/*
+ * Actually an rtld-elf-cap symbol, but declared here so it is available to
+ * applications.
+ */
+int	ld_libcache_lookup(const char *libname, int *fdp);
+int	ld_insandbox(void);
+/*
+ * If this call fails because the buffer 'fds' is too small, 'fdlen' will contain
+ * the size of the array which is actually required.
+ */
+int	ld_libdirs(int *fds, int *fdlen);
+
+/*
+ * Applications may declare an alternative entry point to the default ELF
+ * entry point for their binary, which will be used in preference to 'main'
+ * in the sandbox environment.
+ */
+int	cap_main(int argc, char *argv[]);
+
+__END_DECLS
+
+#endif /* !_LIBCAPSICUM_H_ */
